//
//  ImageViewWithInitials.m
//  Igor
//
//  Created by Igor Ostriz on 11/06/15.
//  Copyright (c) 2015 Igor. All rights reserved.
//


#import "ImageViewWithInitials.h"


@implementation ImageViewWithInitials
{
    UILabel *_initialsLabel;
}

- (instancetype)init
{
    self = [super init];
    [self _init];
    return self;
}
- (id)initWithCoder:(NSCoder *)aDecoder
{
    self = [super initWithCoder:aDecoder];
    [self _init];
    return self;
}
- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    [self _init];
    return self;
}
- (instancetype)initWithImage:(UIImage *)image
{
    self = [super initWithImage:image];
    [self _init];
    return self;
}
- (instancetype)initWithImage:(UIImage *)image highlightedImage:(UIImage *)highlightedImage
{
    self = [super initWithImage:image highlightedImage:highlightedImage];
    [self _init];
    return self;
}

- (void)_init
{
    self.clipsToBounds = YES;
//    self.backgroundColor = [UIColor roundedProfileBackground];
    // this kills scroll
//    self.layer.borderWidth = 1;
//    self.layer.borderColor = [UIColor roundedProfileBorder].CGColor;
//    self.layer.cornerRadius = self.width / 2.;
    
    _initialsLabel = [[UILabel alloc] initWithFrame:self.bounds];
    _initialsLabel.textAlignment = NSTextAlignmentCenter;
    _initialsLabel.font = [UIFont boldSystemFontOfSize:14];
    _initialsLabel.textColor = [UIColor colorWithRed:183/255. green:183/255. blue:183/255. alpha:1];
    [self addSubview:_initialsLabel];
}

- (UILabel *)initialsLabel
{
    return _initialsLabel;
}


- (void)setInitials:(NSString *)initials
{
    _initialsLabel.text = initials;
    if (initials.length) {
         if (_initialsLabel.hidden) _initialsLabel.hidden = NO;
        [_initialsLabel sizeToFit];
    }
    else {
        if (!_initialsLabel.hidden) _initialsLabel.hidden = YES;
    }
    
    [_initialsLabel setNeedsDisplay];
}
- (NSString *)initials
{
    return _initialsLabel.text;
}

- (void)layoutSubviews
{
    [super layoutSubviews];
    _initialsLabel.center = CGPointMake(CGRectGetMidX(self.bounds), CGRectGetMidY(self.bounds));
}

@end
