//
//  RecipientsCellCollectionViewCell.m
//  RecipientsViewController
//
//  Created by Igor Ostriz on 18/01/2017.
//  Copyright © 2017 Igor. All rights reserved.
//


#import "ImageViewWithInitials.h"
#import "RecipientsCell.h"


@implementation RecipientsCell
{
    __weak IBOutlet ImageViewWithInitials *_imageView;
    __weak IBOutlet UILabel *_nameLabel;
    
}

+ (CGSize)sizeForCellExpanded:(BOOL)expanded
{
    if (expanded) {
        return CGSizeMake(144, 50);
    }
    return CGSizeMake(50, 50);
}

- (void)awakeFromNib {
    [super awakeFromNib];
    
}

- (void)setModel:(Contact *)model
{
    _model = model;
    [self _setImage:_imageView forContact:_model];

}

// lazy instatiation
- (UIImage *)defaultImage
{
    static UIImage *__defaultImage;
    
    if (!__defaultImage) {
        __defaultImage = [UIImage imageNamed:@"user-profile-medium"];
    }
    return __defaultImage;
    
}

- (void)_setImage:(ImageViewWithInitials *)imageView forContact:(Contact *)contact
{
    if (contact.profileImage) {
        [imageView setImage:[UIImage imageWithData:[contact profileImage]]];
        imageView.initials = @"";
    }
    else {
        [imageView setImage:[self defaultImage]];
        imageView.initials = contact.initials;
    }
}


- (void)setSelected:(BOOL)selected
{
    [super setSelected:selected];
}

@end
