//
//  RecipientsMultiSecionController.m
//  RecipientsViewController
//
//  Created by Igor on 25/01/2017.
//  Copyright © 2017 Igor. All rights reserved.
//


#import "Contact.h"
#import "RecipientsCell.h"
#import "RecipientsMultiSectionController.h"
#import "RecipientsMultiViewController.h"


@implementation RecipientsMultiModel

- (instancetype)init
{
    self = [super init];
    _selected = NO;
    return self;
}

- (BOOL)isSelected
{
    return _selected;
}

- (id<NSObject>)diffIdentifier
{
    return self;
}

- (BOOL)isEqualToDiffableObject:(id)object
{
    if (self.selected == [object isSelected])
        return YES;
    
    return NO;
}

@end



@interface RecipientsMultiSectionController ()

@property (nonatomic) RecipientsMultiModel *model;


@end


@implementation RecipientsMultiSectionController

- (instancetype)init
{
    self = [super init];
    self.inset = UIEdgeInsetsMake(0, 4, 0, 0);
    self.minimumInteritemSpacing = 0;
    self.minimumLineSpacing = 0;
    return self;
}

- (void)deselect
{
     self.parent.selectedContactIndex = -1;
}
- (void)select
{
    NSInteger index = [self.parent.contacts indexOfObject:_model.contact];
    NSAssert(index != NSNotFound, @"Argh!!");
    
    self.parent.selectedContactIndex = index;
}

- (void)didUpdateToObject:(id)object
{
    if (!self.model)
        self.model = [RecipientsMultiModel new];
    self.model.contact = object;
}

- (void)didSelectItemAtIndex:(NSInteger)index
{
    if (_model.selected)
        [self deselect];
    else
        [self select];
    
    
    [self.collectionContext reloadInSectionController:self atIndexes:[NSIndexSet indexSetWithIndex:index]];
}

- (CGSize)sizeForItemAtIndex:(NSInteger)index
{
    return [RecipientsCell sizeForCellExpanded:_model.selected];
}

- (NSInteger)numberOfItems
{
    return 1;
}

- (UICollectionViewCell *)cellForItemAtIndex:(NSInteger)index
{
    RecipientsCell *cell = [self.collectionContext dequeueReusableCellWithNibName:@"RecipientsCell" bundle:nil forSectionController:self atIndex:index];
    cell.model = _model.contact;
    return cell;
}





@end
