//
//  RecipientsController.m
//  RecipientsViewController
//
//  Created by Igor Ostriz on 18/01/2017.
//  Copyright © 2017 Igor. All rights reserved.
//


#import "Contact.h"
#import "RecipientsCell.h"
#import "RecipientsSectionController.h"



@implementation RecipientsModel


- (instancetype)init
{
    self = [super init];
    _selectedIndex = -1;
    return self;
}

- (id<NSObject>)diffIdentifier
{
    return self;
}

- (BOOL)isEqualToDiffableObject:(id)object
{
    if ([self isEqual:object])
        return YES;
    
    return NO;
}


@end





@implementation RecipientsSectionController
{
    RecipientsModel *_model;
}

- (instancetype)init
{
    self = [super init];
    self.inset = UIEdgeInsetsMake(0, 4, 0, 4);
    self.minimumInteritemSpacing = 4;
    self.minimumLineSpacing = 4;
    return self;
}

- (void)deselectIndex:(NSInteger)index
{
    _model.selectedIndex = -1;
    //... other stuff
}
- (void)selectIndex:(NSInteger)index
{
    _model.selectedIndex = index;
    //... other stuff
}

- (void)didUpdateToObject:(id)object
{
    _model = object;
}

- (void)didSelectItemAtIndex:(NSInteger)index
{
    if (index == _model.selectedIndex)
        [self deselectIndex:index];
    else
        [self selectIndex:index];
    

    [self.collectionContext reloadInSectionController:self atIndexes:[NSIndexSet indexSetWithIndex:index]];
}

- (CGSize)sizeForItemAtIndex:(NSInteger)index
{
    return [RecipientsCell sizeForCellExpanded:(_model.selectedIndex == index)];
}

- (NSInteger)numberOfItems
{
    return _model.contacts.count;
}

- (UICollectionViewCell *)cellForItemAtIndex:(NSInteger)index
{
    RecipientsCell *cell = [self.collectionContext dequeueReusableCellWithNibName:@"RecipientsCell" bundle:nil forSectionController:self atIndex:index];
    cell.model = _model.contacts[index];
    return cell;
}



@end
