//
//  RecipientsViewController.m
//  RecipientsViewController
//
//  Created by Igor Ostriz on 17/01/2017.
//  Copyright © 2017 Igor. All rights reserved.
//

@import IGListKit;
#import "Contact.h"
#import "RecipientsCell.h"
#import "RecipientsSectionController.h"
#import "RecipientsSingleViewController.h"


@interface RecipientsSingleViewController () <IGListAdapterDataSource>

@end


@implementation RecipientsSingleViewController
{
    IGListCollectionView *_collectionView;
    IGListAdapter *_adapter;
    UIView *_emptyView;

    RecipientsSectionController *sc_;

    RecipientsModel *_model;
}


- (void)viewDidLoad
{
    [super viewDidLoad];
    
    UICollectionViewFlowLayout *layout = [[UICollectionViewFlowLayout alloc] init];
    layout.scrollDirection = UICollectionViewScrollDirectionHorizontal;
    _collectionView = [[IGListCollectionView alloc] initWithFrame:CGRectZero collectionViewLayout:layout];
    _collectionView.alwaysBounceVertical = NO;
    _collectionView.alwaysBounceHorizontal = YES;
    _collectionView.backgroundColor = [UIColor yellowColor];
    
    _adapter = [[IGListAdapter alloc] initWithUpdater:[IGListAdapterUpdater new] viewController:self workingRangeSize:0];
    _adapter.collectionView = _collectionView;
    _adapter.dataSource = self;
    
    
    
    _model = [RecipientsModel new];
    [self.view addSubview:_collectionView];
}


- (void)viewWillLayoutSubviews
{
    [super viewWillLayoutSubviews];
    _collectionView.frame = self.view.frame;
}

- (void)setContacts:(NSArray<id> *)contacts
{
    _contacts = contacts;
    _model.contacts = contacts;
    [_adapter performUpdatesAnimated:YES completion:nil];
}


#pragma mark - RecipientsViewControllerDlegate

- (void)addContact:(__autoreleasing Contact *)contact
{
    // ...
    [_adapter performUpdatesAnimated:YES completion:nil];
}

- (void)removeContact:(__autoreleasing Contact *)contact
{
    // ...
    [_adapter performUpdatesAnimated:YES completion:nil];
}

- (void)highlightNoRecipients
{}



#pragma mark - IGListAdapterDataSource

- (IGListSectionController<IGListSectionType> *)listAdapter:(IGListAdapter *)listAdapter sectionControllerForObject:(id)object
{
    return sc_;
}

- (NSArray<id<IGListDiffable>> *)objectsForListAdapter:(IGListAdapter *)listAdapter
{
    if (!sc_)
        sc_ = [[RecipientsSectionController alloc] init];
    return _model ? @[_model] : nil;
}

- (UIView *)emptyViewForListAdapter:(IGListAdapter *)listAdapter
{
    if (!_emptyView)
        _emptyView = [UIView new];
    
    return _emptyView;
}

@end
