//
//  RecipientsViewController.m
//  RecipientsViewController
//
//  Created by Igor Ostriz on 26/01/2017.
//  Copyright © 2017 Igor. All rights reserved.
//


#import "RecipientsCell.h"
#import "RecipientsViewController.h"


@interface RecipientsViewController () <UICollectionViewDataSource, UICollectionViewDelegate, UICollectionViewDelegateFlowLayout>

@end


@implementation RecipientsViewController
{
    UICollectionView *_collectionView;
    
    NSInteger _selectedContactIndex;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    UICollectionViewFlowLayout *layout = [[UICollectionViewFlowLayout alloc] init];
    layout.scrollDirection = UICollectionViewScrollDirectionHorizontal;
    layout.minimumLineSpacing = 4.;
    layout.minimumInteritemSpacing = 4.;
    layout.itemSize = [RecipientsCell sizeForCellExpanded:NO];
    layout.sectionInset = UIEdgeInsetsMake(0., 4., 0., 4.);

    _collectionView = [[UICollectionView alloc] initWithFrame:CGRectZero collectionViewLayout:layout];
    _collectionView.alwaysBounceVertical = NO;
    _collectionView.alwaysBounceHorizontal = YES;
    _collectionView.backgroundColor = [UIColor orangeColor];
    
    [_collectionView registerNib:[UINib nibWithNibName:@"RecipientsCell" bundle:nil] forCellWithReuseIdentifier:@"recipientsCellID"];
    _collectionView.dataSource = self;
    _collectionView.delegate = self;
    
    _selectedContactIndex = -1;
    
    [self.view addSubview:_collectionView];
}

- (void)viewWillLayoutSubviews
{
    [super viewWillLayoutSubviews];
    _collectionView.frame = self.view.frame;
}


#pragma mark - Data Source

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section
{
    return self.contacts.count;
}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath
{
    RecipientsCell *cell = [_collectionView dequeueReusableCellWithReuseIdentifier:@"recipientsCellID" forIndexPath:indexPath];
    NSAssert(cell, @"YCK!");
    cell.model = self.contacts[indexPath.item];
    return cell;
}

- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath
{

    if (indexPath.item == _selectedContactIndex)
        _selectedContactIndex = -1;     // deselect
    else
        _selectedContactIndex = indexPath.item;

    [UIView animateWithDuration:0.35 delay:0.0 usingSpringWithDamping:0.7 initialSpringVelocity:0.0 options:0
                     animations:^{
                         [_collectionView performBatchUpdates:nil completion:nil];
                     } completion:nil];
}

- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout sizeForItemAtIndexPath:(NSIndexPath *)indexPath
{
    return [RecipientsCell sizeForCellExpanded:indexPath.item == _selectedContactIndex];
}


@end
